import os

from PyQt5 import uic
from PyQt5.QtWidgets import QDialog
from PyQt5.QtCore import Qt

FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'ui', 'custom_edition.ui'))


class CtrlCraftCustomEdition(QDialog, FORM_CLASS):

    def __init__(self,path, parent=None):
        """Constructor."""
        super(CtrlCraftCustomEdition, self).__init__(parent)
        self.path=path if os.path.exists(path) else path+'.sample'
        self.setupUi(self)
        self.__initTextEdit()

        self.mCancelButton.clicked.connect(self.__close)
        self.mSaveButton.clicked.connect(self.__save)

    def __close(self):
        self.close()

    def __save(self):
        txt = self.mCustomTextEdit.toPlainText()
        self.path = self.path[:-7] if self.path[-7:] == '.sample' else self.path
        with open(self.path,'w') as dst_file:
            dst_file.write(txt)
        self.close()

    def __initTextEdit(self):
        text_str = ''
        with open(self.path) as text:
            for i in text.readlines():
                text_str += i
        self.mCustomTextEdit.insertPlainText(text_str)
