# -*- coding: utf-8 -*-
"""
/***************************************************************************
 CtrlCraftDialogChartEstimatedBlocs
                                 A QGIS plugin
 Areva - plugin for displaying 3D mines
                             -------------------
        begin                : 2017-09-12
        git sha              : $Format:%H$
        copyright            : (C) 2017 by Oslandia
        email                : sylvain.beorchia@oslandia.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os
import csv

from PyQt5 import uic
from PyQt5.QtWidgets import (QFileDialog,
                         qApp,
                         QLabel,
                         QDialog)

from qgis.gui import QgsMessageBar

from CtrlCraft import CtrlCraftLogger

FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'ui', 'import_db.ui'))


class CtrlCraftDatabaseImport(QDialog, FORM_CLASS):
    """
    Dialog to import Slabs in database.
    """

    def __init__(self, data, rtkube, project, projIni, deposit, parent=None):
        super(CtrlCraftDatabaseImport, self).__init__(parent)
        self.setupUi(self)
        self.data = data
        self.rtkube = rtkube
        self.project = project
        self.projIni = projIni
        self.deposit = deposit
        self.updated = False

        # self.config = self.__populateProjComboBox()
        self.mCancelButton.clicked.connect(self.__close)
        self.mImportButton.clicked.connect(self.__import)
        self.mSelectButton.clicked.connect(self.__select)

        self.mProgressBar.setValue(0)
        self.mLabel.setText('')

    def __close(self):
        self.close()

    def __select(self):
        filename, _ = QFileDialog.getOpenFileName(self, self.tr("Dump file"), filter="*.dump")

        if filename:
            self.mLineEdit.setText(filename)

    # def __populateProjComboBox(self):
    #     config = configparser.ConfigParser()
    #     config.read(self.projIni)
    #     for deposit in config:
    #         self.mProjComboBox.addItem(deposit)
    #     self.mProjComboBox.setCurrentIndex(self.mProjComboBox.findText(self.deposit) if self.mProjComboBox.findText(self.deposit) != -1 else 0)
    #     return config

    def __import(self):
        filename = self.mLineEdit.text()
        if not filename:
            return

        # deposit = self.mProjComboBox.currentText()
        self.mSelectButton.setEnabled(False)
        self.mCancelButton.setEnabled(False)
        self.mImportButton.setEnabled(False)

        self.mLabel.setText(self.tr('Import database...'))
        self.mProgressBar.setMinimum(0)
        self.mProgressBar.setMaximum(0)
        qApp.processEvents()

        self.rtkube.save = False
        self.project.close()
        self.data.import_dump(self.mLineEdit.text())
        self.data.open()
        # if deposit != 'DEFAULT':
        #     customProj=[float(self.config[deposit][i]) for i in ['x','y','z']]
        #     self.data.translate(customProj)
        self.project.load()

        self.rtkube.layer = self.project.probeLayer()
        self.rtkube.save = True

        self.mLabel.setText(self.tr('Database correctly imported.'))
        self.mCancelButton.setEnabled(True)
        self.mProgressBar.setMaximum(100)
        self.mProgressBar.setValue(100)

        self.updated = True
