from PyQt5 import QtWidgets, uic
from PyQt5.QtCore import Qt

import os

FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'ui', 'level_filter.ui'))

class CtrlCraftLevelFilter(QtWidgets.QDialog, FORM_CLASS):

    def __init__(self, data, actualLevel, deposit=None, panel=None, blast=None, parent=None):
        super(CtrlCraftLevelFilter, self).__init__(parent)
        self.data = data

        self.setupUi(self)

        idx = 0
        if actualLevel == -1:
            levels = self.data.get_removed_levels(deposit, panel, blast)
        else:
            levels = self.data.get_levels(deposit, panel, blast)

        for i, l in enumerate(levels):
            if l[1] == actualLevel:
                idx = i
            self.mLevels.addItem(str(l[0]), l[1])

        self.mLevels.setCurrentIndex(idx)

